//this file is part of aMule
//aMule Copyright (C)2003 aMule Team ( http://www.amule-project.net )
//This file Copyright (C)2003 Kry (elkry@sourceforge.net  http://www.amule-project.net )
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.#include <stdio.h>
			
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#if !defined( __WXMSW__ )
#include <unistd.h>
#else
#define AMULECMDDLG 1
#endif
#include "TextClient.h"
#include "MD5Sum.h"

#define CMD_ID_QUIT -1
#define CMD_ID_HELP 1
#define CMD_ID_STATS 2
#define CMD_ID_SHOW 3
#define CMD_ID_RESUME 4
#define CMD_ID_PAUSE 5
#define CMD_ID_SRVSTAT 6
#define CMD_ID_CONN 7
#define CMD_ID_DISCONN 8

#define APP_INIT_SIZE_X 640
#define APP_INIT_SIZE_Y 480

IMPLEMENT_APP(CamulecmdApp)

#ifdef AMULECMDDLG
// IDs for the controls and the menu commands
enum
{
    // menu items
    amulecmd_Quit = 1,

    // it is important for the id corresponding to the "About" command to have
    // this standard value as otherwise it won't be handled properly under Mac
    // (where it is special and put into the "Apple" menu)
    amulecmd_About = wxID_ABOUT,
    Event_Comand_ID = 32001,
    amuleFrame_ID = 32000 
};


BEGIN_EVENT_TABLE(CamulecmdFrame, wxFrame)
    EVT_MENU(amulecmd_Quit,  CamulecmdFrame::OnQuit)
    EVT_MENU(amulecmd_About, CamulecmdFrame::OnAbout)
//    EVT_TEXT(Event_Comand_ID, CamulecmdFrame::OnComandChange)
    EVT_TEXT_ENTER(Event_Comand_ID, CamulecmdFrame::OnComandEnter)
    EVT_SIZE      (CamulecmdFrame::OnSize)
END_EVENT_TABLE()
#endif

MuleConnection *	conn = NULL;
MuleClient *				client;
char *cmdargs = NULL;

wxConnectionBase *MuleClient::OnMakeConnection()
{
    return new MuleConnection;
}

bool MuleConnection::OnAdvise(const wxString& topic, const wxString& item, wxChar *data, int size, wxIPCFormat format)
{
    return TRUE;
}


void Show(char *Stringformat,...) {
	char bufferline[5000];

	va_list argptr;
	va_start(argptr, Stringformat);
	vsnprintf(bufferline, 5000, Stringformat, argptr);
	va_end(argptr);
	#ifndef AMULECMDDLG
	printf("%s\n",bufferline);
	#else
	theApp.frame->log_text->AppendText(wxString::Format("%s\n",bufferline));
	//wxLogMessage(_T(bufferline));
	#endif
}

bool MuleConnection::OnDisconnect()
{
	Show("Disconnected: aMule might have exited");
	#ifndef AMULECMDDLG
	theApp.OnExit();
	#else
	if (theApp.frame) {	
		wxCommandEvent Temp;
		theApp.frame->OnQuit(Temp);
	}
	#endif
 	conn = NULL;
    return wxConnection::OnDisconnect();
}

void ShowGreet() {
	Show("\n---------------------------------");
	Show("|       aMule text client       |");
	Show("---------------------------------\n");
	Show("\nUse 'Help' for command list\n");
}

void ShowHelp() {
	Show("\n->Help: Avalaible commands :\n");	
	Show("Quit: Exits Textclient.\t\t\t\t\tSyns: quit, Exit, exit");	
	Show("Help: Shows this help.\t\t\t\t\tSyns: help");	
	Show("Stats: Shows statistics.\t\t\t\tSyns: stats");	
	Show("Show DL: Shows Download queue");	
	Show("Resume n: Resume file number n.\t\t\t\tSyns: resume");
	Show("Pause n: Pauses file number n.\t\t\t\tSyns: pause");
	Show("ServerStatus: Tell us if connected/not connected. \tSyns: serverstatus");
	Show("Connect: Tries to connect to any server.\t\tSyns: connect");
	Show("\tWARNING: Doesn't warn if failed.");
	Show("Disconnect: Disconnect from server. \t\t\tSyns: disconnect\n");
	Show("->End of listing");
}
#ifndef AMULECMDDLG
void GetCommand(char * buffer) {
	Show("\naMule$ "); 
	fflush(stdin);
	gets(buffer);
}
#else
void GetCommand(char * buffer) {
	strcpy(buffer,wxGetTextFromUser(_T("Command?"),_T("Enter Command")).c_str());;
}
#endif

int GetIDFromString(char* buffer) {
	if ((strncmp(buffer,"Quit",4)==0) || (strncmp(buffer,"quit",4)==0) || (strncmp(buffer,"Exit",4)==0) || (strncmp(buffer,"exit",4) ==0)) {
		return(CMD_ID_QUIT);
	} else if ((strncmp(buffer,"Help",4)==0) || (strncmp(buffer,"help",4)==0)) {
		return(CMD_ID_HELP);
	} else if ((strncmp(buffer,"Stats",5)==0) || (strncmp(buffer,"stats",5)==0)) {
		return(CMD_ID_STATS);
	} else if ((strncmp(buffer,"Show",4)==0) || (strncmp(buffer,"show",4)==0)) {
		cmdargs = (buffer + 5);
		return(CMD_ID_SHOW);
	} else if ((strncmp(buffer,"pause",5)==0) || (strncmp(buffer,"Pause",5)==0)) {
		cmdargs = (buffer + 6);
		return(CMD_ID_PAUSE);
	} else if ((strncmp(buffer,"resume",6)==0) || (strncmp(buffer,"Resume",6)==0)) {
		cmdargs = (buffer + 7);
		return(CMD_ID_RESUME);
	} else if ((strncmp(buffer,"serverstatus",12)==0) || (strncmp(buffer,"ServerStatus",12)==0)) {
		return(CMD_ID_SRVSTAT);
	} else if ((strncmp(buffer,"connect",7)==0) || (strncmp(buffer,"Connect",7)==0)) {
		return(CMD_ID_CONN);
	} else if ((strncmp(buffer,"disconnect",10)==0) || (strncmp(buffer,"Disconnect",10)==0)) {
		return(CMD_ID_DISCONN);
	}
	return(0);
}

void Process_Answer(int ID,char* answer) {
	char* t;
	t=strtok(answer,"\n");
	while (t!=NULL) {
		Show("%s",t);
		t=strtok(NULL,"\n");
	}
}


int ProcessCommand(int ID) {
	int fileID;
	char reqbuffer [256];	
	switch (ID) {
				case CMD_ID_HELP:
					ShowHelp();
				    break;
 				case CMD_ID_STATS:
					Process_Answer(CMD_ID_STATS, conn->Request("STATS", NULL));
				break;
 				case CMD_ID_SRVSTAT:
					Process_Answer(CMD_ID_SRVSTAT, conn->Request("CONNSTAT", NULL));
				break;
 				case CMD_ID_CONN:
					Process_Answer(CMD_ID_CONN, conn->Request("RECONN", NULL));
				break;
 				case CMD_ID_DISCONN:
					Process_Answer(CMD_ID_DISCONN, conn->Request("DISCONN", NULL));
				break;
 				case CMD_ID_PAUSE:
					if (sscanf(cmdargs,"%i",&fileID)) {
						sprintf(reqbuffer,"PAUSE%i",fileID);
				    	Process_Answer(CMD_ID_PAUSE, conn->Request(reqbuffer, NULL));
					} else Show("Not a valid number");
				break;
 				case CMD_ID_RESUME:
					if (sscanf(cmdargs,"%i",&fileID)) {
						sprintf(reqbuffer,"RESUME%i",fileID);
				    	Process_Answer(CMD_ID_RESUME, conn->Request(reqbuffer, NULL));
					} else Show("Not a valid number");
				break;
 				case CMD_ID_SHOW:
					if (strncmp(cmdargs,"DL",2)==0) {
							Process_Answer(CMD_ID_SHOW, conn->Request("DL_QUEUE", NULL));
					} else if (strncmp(cmdargs,"UL",2)==0) {
							Process_Answer(CMD_ID_SHOW, conn->Request("UL_QUEUE", NULL));
					} else Show("Hint: Use Show DL or Show UL");
				break;
				default:
					return(-1);
					break;
			}
	return(0);
}
bool Parse_Command(char* buffer) {
	int cmd_ID;
	cmd_ID=GetIDFromString(buffer);
		if (cmd_ID) {
			if (cmd_ID==CMD_ID_QUIT) {
				return true;
			} else {
					if (ProcessCommand(cmd_ID)<0) {
						Show("Error processing command - should never happen! Report bug, please");
					} 
			}
		} else Show("Syntax error!");
	return false;
}

void TextClientShell() {
	char buffer[256];

	bool The_End=false;
	do {
		GetCommand(buffer);
		The_End = Parse_Command(buffer);
	} while (!The_End);
}

#ifndef AMULECMDDLG

bool CamulecmdApp::OnCmdLineParsed(wxCmdLineParser& amulecmd_parser) {
	
	bool result = true;
	
	result = wxApp::OnCmdLineParsed(amulecmd_parser);
	
	wxString TempStr;
	TempStr = "rh";
	if (!amulecmd_parser.Found(TempStr,&hostName)) {
		hostName = "localhost";
	}
	
	long port;
	TempStr = "p";
	if (!amulecmd_parser.Found(TempStr,&port)) {
		server = getenv("HOME") + wxString("/.aMule/muleconn");	;
	} else {
		server = wxString::Format("%li",port);
	}
	
	return result;
}

#endif
#ifdef AMULECMDDLG
int CamulecmdApp::OnExit() {

	if (conn) {
		delete conn;
	}
	if (client) {
    	delete client;
	}
}

bool CamulecmdApp::OnInit() {

      frame = new CamulecmdFrame(_T("amulecmd DLG"),
                                 wxPoint(50, 50), wxSize(APP_INIT_SIZE_X, APP_INIT_SIZE_Y));

      // and show it (the frames, unlike simple controls, are not shown when
      // created initially)
      frame->Show(TRUE);
#else
int CamulecmdApp::OnRun() {
#endif
	
	Show("\nThis is amulecmd (TextClient)\n");

	wxString * temp_wxpasswd;

	#ifndef AMULECMDDLG
	char* t_passwd;
	t_passwd = getpass("Enter password for mule connection (return if no pass defined): ");
	if (strlen(t_passwd)>0) {
		temp_wxpasswd = new wxString(MD5Sum(wxT(t_passwd)).GetHash());
	} else temp_wxpasswd = new wxString("");
	#else
	hostName = wxGetTextFromUser(_T("Enter hostname or ip of the box running aMule"),_T("Enter Hostname"),_T("localhost"));
	server = wxGetTextFromUser(_T("Enter port for aMule's External Connection"),_T("Enter Port"),_T("4713"));
	temp_wxpasswd = new wxString(::wxGetPasswordFromUser(_T("Enter password for mule connection (OK if no pass defined)"),_T("Enter Password")));
	if (strlen(temp_wxpasswd->GetData())>0) {
		temp_wxpasswd = new wxString(MD5Sum(*temp_wxpasswd).GetHash());
	} else temp_wxpasswd = new wxString("");
	#endif


	wxString passwd = wxString::Format("aMulecmd IPC %s",temp_wxpasswd->GetData());
	//printf("pass |%s| MD5HASH = |%s|\n",t_passwd,temp_wxpasswd->GetData());;
	delete temp_wxpasswd;

	Show("\nCreating client...");
	client = new MuleClient;
	Show("Now, doing connection....");
	
	Show("Using host %s port %s",hostName.c_str(), server.c_str());
	conn = (MuleConnection *) client->MakeConnection(hostName, server, passwd);
	if (!conn) {
		// no connection => close gracefully
		Show("aMule is not running, not accepting connections or wrong password supplied");
		} else {
		ShowGreet();

#ifndef AMULECMDDLG			
		TextClientShell();
		Show("\nOk, exiting Text Client...");
		conn->Disconnect();
	}
	
	if (conn) {
		delete conn;
	}
	if (client) {
    	delete client;
	}
#else
	}
#endif
	return TRUE;
}

#ifdef AMULECMDDLG

CamulecmdFrame::CamulecmdFrame(const wxString& title, const wxPoint& pos, const wxSize& size, long style)
       : wxFrame(NULL, amuleFrame_ID, title, pos, size, style)
{

    wxMenu *menuFile = new wxMenu;
    menuFile->Append(amulecmd_Quit, _T("E&xit\tAlt-X"), _T("Quit amulecmd"));

    wxMenu *helpMenu = new wxMenu;
    helpMenu->Append(amulecmd_About, _T("&About...\tF1"), _T("Show about dialog"));

    // now append the freshly created menu to the menu bar...
    wxMenuBar *menuBar = new wxMenuBar();
    menuBar->Append(menuFile, _T("&File"));
    menuBar->Append(helpMenu, _T("&Help"));

    // ... and attach this menu bar to the frame
    SetMenuBar(menuBar);

    log_text = new wxTextCtrl(this, -1, _T(""), wxPoint(2, 2), wxSize(APP_INIT_SIZE_X-4,APP_INIT_SIZE_Y-30-4), wxTE_MULTILINE | wxTE_READONLY);
    log_text->SetBackgroundColour(wxT("wheat"));   

    cmd_control = new wxTextCtrl(this,Event_Comand_ID, _T(""), wxPoint(2,APP_INIT_SIZE_Y-30-4), wxSize(APP_INIT_SIZE_X-4,30), wxTE_PROCESS_ENTER);
    cmd_control->SetBackgroundColour(wxT("wheat"));
}

void CamulecmdFrame::OnQuit(wxCommandEvent& WXUNUSED(event))
{
    // TRUE is to force the frame to close
    Show("\nOk, exiting Text Client...");
    Close(TRUE);
}

void CamulecmdFrame::OnAbout(wxCommandEvent& WXUNUSED(event))
{
    wxString msg;
    msg.Printf( _T("amulecmd DLG version\n")
                _T("Using %s\n(c) aMule Dev Team"), wxVERSION_STRING);

    wxMessageBox(msg, _T("About amulecmd"), wxOK | wxICON_INFORMATION, this);
}

void CamulecmdFrame::OnComandEnter(wxCommandEvent& WXUNUSED(event)) { 

	if (cmd_control->GetLineLength(0) == 0) {
		return;
	}
	
	char* buffer = (char *) cmd_control->GetLineText(0).c_str();
	
	if (Parse_Command(buffer)) {
		Close(TRUE);
	}
	cmd_control->Clear();
}

void CamulecmdFrame::OnSize( wxSizeEvent& WXUNUSED(event) )
{
    int x = 0;
    int y = 0;
    GetClientSize( &x, &y );

    if (log_text) log_text->SetSize( 2, 2, x-4, y-30 - 4 );
    if (cmd_control) cmd_control->SetSize( 2, y-30-2, x-4,30);
}
#endif
